#ifndef morpheo_behavioural_core_multi_execute_loop_execute_loop_register_unit_Parameters_h
#define morpheo_behavioural_core_multi_execute_loop_execute_loop_register_unit_Parameters_h

/*
 * $Id: Parameters.h 88 2008-12-10 18:31:39Z rosiere $
 *
 * [ Description ]
 * 
 */

#include "Common/include/Debug.h"
#include "Behavioural/include/Parameters.h"
#include "Behavioural/Generic/RegisterFile/include/Parameters.h"
#include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/include/Parameters.h"

namespace morpheo {
namespace behavioural {
namespace core {
namespace multi_execute_loop {
namespace execute_loop {
namespace register_unit {


  class Parameters : public morpheo::behavioural::Parameters
  {
    //-----[ fields ]------------------------------------------------------------
  public : uint32_t    _nb_ooo_engine            ;
//public : uint32_t    _size_general_data        ;
//public : uint32_t    _size_special_data        ;
  public : uint32_t    _nb_gpr_read              ;
  public : uint32_t    _nb_gpr_write             ;
  public : uint32_t    _nb_gpr_bank              ;
  public : uint32_t    _nb_gpr_port_read_by_bank ;
  public : uint32_t    _nb_gpr_port_write_by_bank;
  public : uint32_t    _nb_spr_read              ;
  public : uint32_t    _nb_spr_write             ;
  public : uint32_t    _nb_spr_bank              ;
  public : uint32_t    _nb_spr_port_read_by_bank ;
  public : uint32_t    _nb_spr_port_write_by_bank;
  public : uint32_t  * _nb_general_register      ;
  public : uint32_t  * _nb_special_register      ;
  public : uint32_t  * _nb_inst_insert_rob       ;
  public : uint32_t  * _nb_inst_retire_rob       ;

//public : bool        _have_port_ooo_engine_id  ;
  public : uint32_t    _size_gpr_address         ;
  public : uint32_t    _size_spr_address         ;

  public : morpheo::behavioural::generic::registerfile::Parameters                                                     ** _param_gpr        ;
  public : morpheo::behavioural::generic::registerfile::Parameters                                                     ** _param_gpr_status ;
  public : morpheo::behavioural::generic::registerfile::Parameters                                                     ** _param_spr        ;
  public : morpheo::behavioural::generic::registerfile::Parameters                                                     ** _param_spr_status ;
  private: morpheo::behavioural::generic::registerfile::registerfile_multi_banked::Parameters                          ** __param_gpr       ;
  private: morpheo::behavioural::generic::registerfile::registerfile_monolithic  ::Parameters                          ** __param_gpr_status;
  private: morpheo::behavioural::generic::registerfile::registerfile_multi_banked::Parameters                          ** __param_spr       ;
  private: morpheo::behavioural::generic::registerfile::registerfile_monolithic  ::Parameters                          ** __param_spr_status;
  public : morpheo::behavioural::core::multi_execute_loop::execute_loop::register_unit::register_unit_glue::Parameters  * _param_glue       ;

    //-----[ methods ]-----------------------------------------------------------
  public : Parameters  (uint32_t    nb_ooo_engine            ,
			uint32_t    size_general_data        ,
			uint32_t    size_special_data        ,
			uint32_t    nb_gpr_read              ,
			uint32_t    nb_gpr_write             ,
			uint32_t    nb_gpr_bank              ,
			uint32_t    nb_gpr_port_read_by_bank ,
			uint32_t    nb_gpr_port_write_by_bank,
			uint32_t    nb_spr_read              ,
			uint32_t    nb_spr_write             ,
			uint32_t    nb_spr_bank              ,
			uint32_t    nb_spr_port_read_by_bank ,
			uint32_t    nb_spr_port_write_by_bank,
			uint32_t  * nb_general_register      ,
			uint32_t  * nb_special_register      ,
			uint32_t  * nb_inst_insert_rob       ,
			uint32_t  * nb_inst_retire_rob       ,
                        bool        is_toplevel=false);

//public : Parameters  (Parameters & param) ;
  public : ~Parameters () ;

  public :        void            copy       (void);

  public :        Parameters_test msg_error  (void);

  public :        std::string   print      (uint32_t depth);
  public : friend std::ostream& operator<< (std::ostream& output_stream,
					    morpheo::behavioural::core::multi_execute_loop::execute_loop::register_unit::Parameters & x);
  };

}; // end namespace register_unit
}; // end namespace execute_loop
}; // end namespace multi_execute_loop
}; // end namespace core

}; // end namespace behavioural
}; // end namespace morpheo              

#endif
